%*************************************************************
%*  Ing. OLDICH EVEEK v rmci projetku FRV 2421/2007/G1 *
%*************************************************************

clear all,
%**************************************************************************
%******** K R I T E R I A *************************************************
%**************************************************************************
poradidelta=1;  %toto je promenna, ktera udava, ktere delta uvazujeme (1 - uvazujeme delta z intervalu(0,1) ; 2 - uvazujeme delta z intervalu (1,2) (podle toho se pak meni v souboru singularsol vstupni soubor z MAPLU

%******* I N P U T   O B L A S T *****************************************
%POZN: integracni polomer se nacita primo z txt souboru ansysu - je tam
%ulozenen ve sloupci SOURR-4. sloupec. - viz radek 37 (hodnoty v metrech)
alfa=0;              % uhel trhliny od zaporne osy X*
FI=0;                % rozevreni
R4=1;                % (mm)   
INV_EPS=500;        % prevracena hodnota epsilon (defakto kolikrat je mensi prirustek nez polomer R4) - uzivame prevracenou hodnotu, jelikoz je to vyhodnejsi pro nazev souboru
G1c = 5^2/10000;     % houzevnatost materialu 1 - substratu
Gic = 10^2/10000;    % houzevnatost rozhrani
ALFAp=0;             % uhel prirustku od 
%**************************************************************************

predponasouboru1=''; 
predponasouboru2=''; 
pripona1=[ 'SDproALFA=',num2str(alfa),'_FI=',num2str(FI),'_R4=',num2str(R4),'_inv_eps=',num2str(INV_EPS)];
pripona2=[ 'DDproALFA=',num2str(alfa),'_FI=',num2str(FI),'_R4=',num2str(R4),'_inv_eps=',num2str(INV_EPS)];
pripona3=['PENproALFA=',num2str(alfa),'_FI=',num2str(FI),'_R4=',num2str(R4),'_inv_eps=',num2str(INV_EPS),'_ALFAp=',num2str(ALFAp)];
cesta = ('MKPdata\');

krucek=1;

for iii=1:3,

if iii==1, pripona=pripona1; Gc=Gic; end;   %index 1 je vyhrazen pro jednoduchy ohyb po rozhrani - SD
if iii==2, pripona=pripona2; Gc=Gic; end;   %index 2 je vyhrazen pro oboustranny ohyb po rozhrani - DD
if iii==3, pripona=pripona3; Gc=G1c; end;   %index 3 je vyhrazen pro penetraci do materialu 1 -substratu - PEN

%******* D O P O C I T A N E   H O D N O T Y *****************************
EPSI=1/INV_EPS ;                      % hodnota pomeru l/R - epsilon
Delka_prirustku = 10^-3*R4 * EPSI ;   % hodnota prirustku trhliny v absolutni velikosti
alfa1=180+alfa ;                      % uhel od kladne osy x k ose vrubu (trhliny)
FI1=alfa1-FI/2 ;                      % uhel od kladne osy x k prvnmu celu vrubu (trhliny)
FI2=alfa1+FI/2 ;                      % uhel od kladne osy x k druhemu celu vrubu (trhliny)
%*************************************************************************************************
%***** N A C T E  S E   S O U B O R   Z   M K P  S    D A T Y  O  U Z L E C H  N A  C E S T E   C1 
%*************************************************************************************************
filename0=[predponasouboru1,'Uzly_IntcestaC1_',pripona,'.txt'];  %'_opacnematerialy',
%f0 = fullfile('D:', 'Ansys', 'Kriteria','ALLinONE','MKPdata', filename0)  %prikaz ktery vytvori komplet cestu k danemu souboru
f0 = fullfile(cesta, filename0)  %prikaz ktery vytvori komplet cestu k danemu souboru
fid=fopen(f0,'r');
 %nacteme prvni serii dat (mezi prvni a druhou hlavickou)  
 A1 = textscan(fid, '%f %f ',1,'headerlines', 0)                                    %nacte se hodnota GSIF a alfaP (je v prvni radce)
 A =  textscan(fid, '%f %f %f %f %f %f %f %f %f %f %f %f %f ','headerlines', 2)  %37 znamena kolik radku se ma cist, 11 znamena kolik radku vynechat
 %SOURFItr, SOURFI, SOURR, POSUVX, POSUVY, POSUVXre, POSUVYre, NAPX,  NAPY, NAPXY,  OBLAST,SFItrabs,  SOURRabs SFItrabs a SOURRabs obsahuji absolutni polarni souradnice daneho bodu na intergracni ceste
fclose(fid)       %uzavre soubor pro cteni

hodnoty = cell2mat(A1);   %cell2mat (prevede CELL na obycejnou matici) - v prvnim
GSIF  = hodnoty(1);     
ALFAp = hodnoty(2);

uzly_pathR1 = cell2mat(A);   %cell2mat (prevede CELL na obycejnou matici)
uzly_pathR1_sort = sortrows(uzly_pathR1,[11,12]);   %nejdrve se seradi podle 11.sloupecku - OBLAST a pak podle uhlu - pocatek na dolnim cele trhliny - sloupecek 12

POSUVKORENEY=0;%-0.000001; %9*10^-7;


%*************************************************************************************************

%*************ZDE SE NACTE INTEGRACNI POLOMER - ze souboru UZLY *****
%RC2 =uzly_pathR2(1,4) * 10^-3;    %ve ctvrtem sloupci jsou hodnoty polomeru integracni cesty - nasobime jeste 10^-3 - prevedeme na metry
%********************************************************************

[k1,r1]   = size(uzly_pathR1_sort)  %k - pocet radku , r - pocet sloupcu

%*************************************************************************************************

%MATICE A a B - CO OBSAHUJE:

%SOURFItr, SOURFI, SOURR, POSUVX, POSUVY, POSUVXre, POSUVYre, NAPX,  NAPY, NAPXY,  OBLAST,
%**************************************************************************
%******Do promenne Asel a Bsel ulozime pouze hodnoty ktere budeme nutne potrebovat do vypoctu Psi integralu (k integraci)************************

 Asel = zeros(k1,12);                         %vytvori prazdnou matici k*12
 Asel(:,1) = uzly_pathR1_sort(:,12);            %do 1. sloupecku ulozime uhel ve stupnich 0-360
 Asel(:,2) = Asel(:,1)* pi/180;                 %do 2. sloupecku ulozime uhel v radianech 0-2pi
 Asel(:,3) = 10^-3*uzly_pathR1_sort(:,13);      %do 3. sloupecku se vzdalenost uzlu od korene hlavni trhliny
 Asel(:,4) = 10^-3*uzly_pathR1_sort(:,4);  %6     %do 4. sloupecku se ulozi UX z MKP (m) %10^3 prevede mm z ansysu na metry - relativn posuv vzhledem ke koreni hlavn trhliny ((:,4)-absolutni posuv))
 Asel(:,5) = 10^-3*uzly_pathR1_sort(:,5)-POSUVKORENEY;  %7     %do 5. sloupecku se ulozi UY z MKP (m) %10^3 prevede mm z ansysu na metry - relativn posuv vzhledem ke koreni hlavn trhliny ((:,5)-absolutni posuv))
 Asel(:,6) = uzly_pathR1_sort(:,8);             %do 6. sloupecku se ulozi SX z MKP (MPa)
 Asel(:,7) = uzly_pathR1_sort(:,9);             %do 7. sloupecku se ulozi SY z MKP (MPa)
 Asel(:,8) = uzly_pathR1_sort(:,10);            %do 8. sloupecku se ulozi SXY z MKP (MPa)
 Asel(:,9) = uzly_pathR1_sort(:,11);            %do 9. se ulozi oblast ve ktere se dany uzel nachazi

 Asel(:,17) = uzly_pathR1_sort(:,12);             %do 17. sloupecku se ulozi uhel ve stupnich 0-360 v absolutnich souradnicich - s pocatkem v koreni trhliny
 Asel(:,18) = 10^-3*uzly_pathR1_sort(:,13);       %do 18. sloupecku se ulozi vzdalenost uzlu od korene hlavni trhliny v metrech

 
 %vypocita singularni reseni na drace C1 (R1)
for t=1:k1,
uheltheta=Asel(t,17);  %zde se v tomto cyklu vypoctou hodnoty singularniho reseni na ceste R1
  [UXsin,UYsin,SXsin,SYsin,SXYsin,delta] = SingularSolution(uheltheta,Asel(t,18),2,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Asel(t,10) = UXsin;  %do 13. sloupecku se ulozi UX singularniho reseni ()
  Asel(t,11) = UYsin;  %do 14. sloupecku se ulozi UY singularniho reseni ()
  Asel(t,12) = SXsin; %*(Asel(t,3))^delta;  %do 15. sloupecku se ulozi SX singularniho reseni ()
  Asel(t,13) = SYsin; %*(Asel(t,3))^delta;  %do 16. sloupecku se ulozi SY singularniho reseni ()
  Asel(t,14) = SXYsin;%*(Asel(t,3))^delta;  %do 17. sloupecku se ulozi SXY singularniho reseni ()
end;
for t=1:k1,
  Asel(t,15) = (Asel(t,3))^delta  ;  %do 15. sloupecku se hodnota (SOURR)^delta  - bude potreba v integralu
  Asel(t,16) = (Asel(t,3))^-delta ;  %do 16. sloupecku se hodnota (SOURR)^-delta - bude potreba v integralu
  Asel(t,19) = (Asel(t,3)/EPSI)^delta ;  %do 19. sloupecku se hodnota (SOURR/EPSI)^delta - bude potreba v integralu
end;

for t=1:k1,
uheltheta=Asel(t,17);  %zde se v tomto cyklu vypoctou hodnoty pomocnho reseni na ceste R1
  [UXpom,UYpom,SXpom,SYpom,SXYpom,delta] = SingularSolution(uheltheta,Asel(t,18),1,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
  Asel(t,20) = UXpom;  %do 19. sloupecku se ulozi UX pomocne reseni (MPa)
  Asel(t,21) = UYpom;  %do 20. sloupecku se ulozi UY pomocne reseni (MPa)
  Asel(t,22) = SXpom; %*(Asel(t,3))^delta;  %do 21. sloupecku se ulozi SX pomocne reseni (MPa)
  Asel(t,23) = SYpom; %*(Asel(t,3))^delta;  %do 22. sloupecku se ulozi SY pomocn reseni (MPa)
  Asel(t,24) = SXYpom;%*(Asel(t,3))^delta;  %do 23. sloupecku se ulozi SXY pomocn reseni (MPa)
end;


PROVEST='NE';   
if PROVEST=='AN',
  %***** PLOT HODNOT Z MATICE Asel(nebo Bsel) -singularni reseni a reseni MKP na ceste C1 nebo C2 (dle volby promenne) **************
Cestaplot=Asel; %Bsel
figure(5),
subplot(2,3,1); 
   plot(Cestaplot(:,17), Cestaplot(:,4),'Color','r','LineWidth',2) ;hold on;
   plot(Cestaplot(:,17), Cestaplot(:,10),'Color','b','LineWidth',2) ;grid on; hold off;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_X (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   legend('MKP reseni','Singularni reseni',2);
subplot(2,3,2); 
   plot(Cestaplot(:,17), Cestaplot(:,5),'Color','r','LineWidth',2) ;hold on;
   plot(Cestaplot(:,17), Cestaplot(:,11),'Color','b','LineWidth',2) ;grid on; hold off;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Posuvy U_Y (m)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   legend('MKP reseni','Singularni reseni',2);
subplot(2,3,4); 
   plot(Cestaplot(:,17), Cestaplot(:,6),'Color','r','LineWidth',2) ;hold on;
   plot(Cestaplot(:,17), Cestaplot(:,12),'Color','b','LineWidth',2) ;grid on; hold off;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_X_X (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   legend('MKP reseni','Singularni reseni',2);
subplot(2,3,5); 
   plot(Cestaplot(:,17), Cestaplot(:,7),'Color','r','LineWidth',2) ;hold on;
   plot(Cestaplot(:,17), Cestaplot(:,13),'Color','b','LineWidth',2) ;grid on; hold off; 
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_Y_Y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   legend('MKP reseni','Singularni reseni',2);
subplot(2,3,6); 
   plot(Cestaplot(:,17), Cestaplot(:,8),'Color','r','LineWidth',2) ;hold on;
   plot(Cestaplot(:,17), Cestaplot(:,14),'Color','b','LineWidth',2) ;grid on; hold off;
   xlim([0 360])
   set(gca,'xtick',[0 45 90 135 180 225 270 315 360])
   xlabel('Uhel od cela trhliny k celu trhliny - []','FontName','times','FontSize',10,'FontWeight','bold'), 
   ylabel('Napeti \sigma_X_Y (MPa)'  ,'FontName','times','FontSize',10,'FontWeight','bold'), 
   legend('MKP reseni','Singularni reseni',2);
  title({'Singularni reseni & MKP reseni';['na ceste C1 - R=',num2str(uzly_pathR1_sort(1,13)),'mm']},'FontName','times','FontSize',14,'FontWeight','bold'), 
  
end;
  
%Nyni vytvorime tabulku hodnot, ktere nasledovne pouzijem pro integraci
%******** TABULKA_PRO_INTEGRACI ***************************************

tabulka_pro_integraciR1     =zeros(k1,8);   %vytvori se prazdna matice o osmi sloupcich a poctu radku k - pocet zaznamu z MKP
tabulka_pro_integraciR1(:,1)=Asel(:,1);     %1. sloupec v matici tabulka_pro_integraci budou uhly nodu 'SOURFI 0-360-pocatekVtrhline
tabulka_pro_integraciR1(:,2)=Asel(:,2);     %2. sloupec budou hodnoty sloupce 1. ale v RADIANECH
tabulka_pro_integraciR1(:,3)=Asel(:,3);     %3. sloupec budou vzdalenosti od korene hl.trhliny
tabulka_pro_integraciR1(:,7)=Asel(:,9);     %7. sloupec bude oznacovat oblast, ve ktere se dany uzel nachazi
tabulka_pro_integraciR1(:,8)=Asel(:,17);    %8. sloupec s uhly v absolutnich polarnich souradnicich s pocatkem v koreni hlavni trhliny

delta    %vypise hodnotu exponentu u posuvu --- r^delta
%Nyn budeme pocitat nasledujici vyraz pro jednotlive uzly a vse ukladat do
%tabulky pro integraci
%S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b
%VEKTOR vnejsi normaly je pro SS maplu ( cos(theta + natoceni), sin(theta + natoceni))
  
nat  = -pi/2 + alfa*pi/180;   %natoceni trhliny vi kladn ose X (osa X smeruje v ansysu o 90 stupnu pootocena k trhline)

%zde se ulozi hodnoty pro integracni cestu C1=R1
prep=0; % je-li hodnota prep nastavena na nulu, tak se dosazuje singularni reseni do tabulky pro integraci a je-li nastavena na 10 tak se dosazuje pomocne reseni
for j=1:k1 
 % Vypocet integralu v citateli 
%                                     (S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b +  S22a*n2*u2b)
    tabulka_pro_integraciR1(j,4)= (Asel(j,6) * cos(Asel(j,2)+nat) * Asel(j,10+prep))  +  (Asel(j,8) * sin(Asel(j,2)+nat) * Asel(j,10+prep))  +  (Asel(j,8) * cos(Asel(j,2)+nat) * Asel(j,11+prep))  +  (Asel(j,7) * sin(Asel(j,2)+nat) * Asel(j,11+prep));  %ve 4. sloupecku bude 1.clen uvnitr integralu v citateli
%                                 (  SXa     *      n1            *    UXb         )  +  (    SXYa  *       n2           *      UXb       )  +  (    SYXa  *        n1          *     UYb        )  +  (    SYa   *        n2          *    UYb         )                *  
    tabulka_pro_integraciR1(j,5)= (Asel(j,12+prep) * cos(Asel(j,2)+nat) * Asel(j,4))  +  (Asel(j,14+prep) * sin(Asel(j,2)+nat) * Asel(j,4))  +  (Asel(j,14+prep) * cos(Asel(j,2)+nat) * Asel(j,5))  +  (Asel(j,13+prep) * sin(Asel(j,2)+nat) * Asel(j,5));   %v 5. sloupecku bude 2.clen uvnitr integralu v citateli
%                                 (  SXb           *     n1             *    UXa   )  +  (     SXYb       *       n2           *      UXa )  +  (     SYXb       *        n1          *     UYa  )  +  (     SYb        *        n2          *    UYa   )                *  
    tabulka_pro_integraciR1(j,6)= (1/(GSIF*EPSI^(2*delta)))*(tabulka_pro_integraciR1(j,4)-tabulka_pro_integraciR1(j,5));

 % Vypocet integralu ve jmenovateli
%                                     (S11a*n1*u1b + S12a*n2*u1b + S21a*n1*u2b + S22a*n2*u2b)
    tabulka_pro_integraciR1(j,9)= (Asel(j,22) * cos(Asel(j,2)+nat) * Asel(j,10))  +  (Asel(j,24) * sin(Asel(j,2)+nat) *  Asel(j,10))  +  (Asel(j,24) * cos(Asel(j,2)+nat) * Asel(j,11))  +  (Asel(j,23) * sin(Asel(j,2)+nat)* Asel(j,11));   %ve 9. sloupecku bude 1.clen uvnitr integralu ve jmenovateli
%                                 (  SXa      *       n1           *    UXb    )  +  (    SXYa   *       n2           *      UXb   )  +  (    SYXa   *        n1          *     UYb   )  +  (    SYa    *        n2         *    UYb    )                *  
    tabulka_pro_integraciR1(j,10)=(Asel(j,12) * cos(Asel(j,2)+nat) * Asel(j,20))  +  (Asel(j,14) * sin(Asel(j,2)+nat) *  Asel(j,20))  +  (Asel(j,14) * cos(Asel(j,2)+nat) * Asel(j,21))  +  (Asel(j,13) * sin(Asel(j,2)+nat)* Asel(j,21));      %v 10. sloupecku bude 2.clen uvnitr integralu ve jmenovateli
%                                 (  SXb      *       n1           *    UXa    )  +  (    SXYb   *       n2           *      UXa   )  +  (    SYXb   *        n1          *     UYa   )  +  (    SYb    *        n2         *    UYa    )                *  
    tabulka_pro_integraciR1(j,11)= tabulka_pro_integraciR1(j,9)-tabulka_pro_integraciR1(j,10);

end;


%*********************SLOZENI TABULKY_PRO_INTEGRACI ************************
%SLOUPCE - cesta C1
% 1-uhly ve stupnich v nich je vycislena prislusna velicina 0-360stupnu
% 2-uhly z 1 v radianech 
% 3-sloupec kde jsou vzdalenosti od korene hl.trhliny
% 4-soucty prvniho clenu v citateli pro vypocet K uzitim psi-integralu - MKP a singularni reseni
% 5-soucty druheho clenu v citateli pro vypocet K uzitim psi-integralu - MKP a singularni reseni
% 6-rozdil obou hodnoty (3-4)- defakto celkova funkcni hodnota integralu v citateli pro K
% 7-sloupec bude oznacovat oblast, ve ktere se dany uzel nachazi
% 8-sloupec s uhly v absolutnich polarnich souradnicich s pocatkem v koreni hlavni trhliny (stupne)
% 9-soucty prvniho clenu ve jmenovateli pro vypocet K uzitim psi-integralu - singulrn a pomocn reseni
%10-soucty druheho clenu ve jmenovateli pro vypocet K uzitim psi-integralu - singulrn a pomocn reseni
%11-rozdil obou hodnoty (9-10)- defakto celkova funkcni hodnota integralu ve jmenovateli pro K
%**************************************************************************

PROVEST='NE';   
if PROVEST=='AN',
figure(6), %vykresli se do grafu 4 funkce kterou vlastne budeme integrovat - cely vnitrek integralu

subplot(2,1,1);
  plot(tabulka_pro_integraciR1(:,8),tabulka_pro_integraciR1(:,6),'Color','b','LineWidth',2),hold on; %integrand na ceste R2
  xlim([0 360]);  set(gca,'xtick',[0 45 90 135 180 225 270 315 360]); grid on;
  title('Prubeh integrovane funkce na ceste C1- citatel K_1','FontName','times','FontSize',8,'FontWeight','bold'), 
  legend(['Integracni cesta C1 - r=',num2str(Asel(1,3)*10^3),'mm'],1);
subplot(2,1,2);
  plot(tabulka_pro_integraciR1(:,8),tabulka_pro_integraciR1(:,11),'Color','b','LineWidth',2),hold on; %integrand na ceste R2
  xlim([0 360]);  set(gca,'xtick',[0 45 90 135 180 225 270 315 360]); grid on;
  title('Prubeh integrovane funkce na ceste C1- jmenovatel K_1','FontName','times','FontSize',8,'FontWeight','bold'), 
  legend(['Integracni cesta C1 - r=',num2str(Asel(1,3)*10^3),'mm'],1);
end;

%INTEGRACE PODEL KRIVEK C1 a C2 - pouzita bude SIMPSONOVA METODA
%***********************************************************
K_C1_citatel=0;  %pocatecni hodnota integralu z K funkce na krivce C1 - citatel K1=PSIint/PSIint
K_C1_jmenovatel=0;  %pocatecni hodnota integralu z K funkce na krivce C1 - jmenovatel K1=PSIint/PSIint
%***********************************************************

X1 = tabulka_pro_integraciR1; %pro zjednoduseni zapisu v dalsich vypoctech, ulozime "tabulku_pro_integraci" do promenne X

%**************************************************************************
%******   I N T E G R A C E   P R E S   C1  a C2   ************************
%**************************************************************************
% Tato integrace bude provedena jednim pruchodem pres celou kivku - nemusi
% byt tedy pili pesn kvli nespojitostem zpsobench rozhrani

pruchod=zeros(2,1);  %kontrolni promenna
%*******zde bude pro integraci pouzita SIMPSONOVA METODA*********Integrace pres C1**
for i=1:2:length(tabulka_pro_integraciR1)-2,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
     K_C1_citatel    = K_C1_citatel    + X1(i+1,3)*((X1(i+2,2)-X1(i,2))/6) * (X1(i,6) + 4*X1(i+1,6) + X1(i+2,6));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1_jmenovatel = K_C1_jmenovatel + X1(i+1,3)*((X1(i+2,2)-X1(i,2))/6) * (X1(i,11) + 4*X1(i+1,11) + X1(i+2,11));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     Kjmen1(pruchod+1)=X1(i+1,3)*((X1(i+2,2)-X1(i,2))/6) * (X1(i,11) + 4*X1(i+1,11) + X1(i+2,11));  %kontrolni promenna
     pruchod(1)=pruchod(1)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%**************************************************************************
K_C1_Simpson = K_C1_citatel /K_C1_jmenovatel;
%*********************************************************************************
%******* Zde bude pro integraci pouzita jednoducha lichobeznikova METODA**********
%*********************************************************************************
K_C1b_citatel(krucek)=0;  %pocatecni hodnota integralu z K funkce na krivce C1 - citatel K1=PSIint/PSIint
K_C1b_jmenovatel(krucek)=0;  %pocatecni hodnota integralu z K funkce na krivce C1 - jmenovatel K1=PSIint/PSIint

pruchodb=0;
for i=1:length(tabulka_pro_integraciR1)-1,   %je zde -2 protoze potrebujeme aby pri i+2 jsme dostali max hodnotu 201 - delka matice X
    K_C1b_citatel(krucek)    = K_C1b_citatel(krucek)    + ((X1(i+1,3)+X1(i,3))/2)*((X1(i+1,2)-X1(i,2))/2) * (X1(i,6) +  X1(i+1,6));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
    K_C1b_jmenovatel(krucek) = K_C1b_jmenovatel(krucek) + ((X1(i+1,3)+X1(i,3))/2)*((X1(i+1,2)-X1(i,2))/2) * (X1(i,11) + X1(i+1,11));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
    pruchodb=pruchodb+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;


K_C1_Lichobeznik(krucek) = K_C1b_citatel(krucek) /K_C1b_jmenovatel(krucek);

%*****************************************************************************************
%*************** I N T E G R A C E   P O   O B L A S T E C H  na C1 SIMPSON ************** 
%*****************************************************************************************
%Zde v nasledujicim  zkusime integraci po castech v kazdem materialu budeme integrovat zvlast- na rozhrani je totiz nespojitost - skokova zmena a ta
%muze pri numericke integraci zpusobovat chybu.
%Bude pouzita SIMPSONOVA METODA

INTBODY_I=0  ; for i=1:length(X1), if X1(i,7)==1 ; INTBODY_I=INTBODY_I+1;   end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci
INTBODY_II=0 ; for i=1:length(X1), if X1(i,7)==2 ; INTBODY_II=INTBODY_II+1;  end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci
INTBODY_III=0; for i=1:length(X1), if X1(i,7)==3 ; INTBODY_III=INTBODY_III+1;end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci
INTBODY_IV=0 ; for i=1:length(X1), if X1(i,7)==4 ; INTBODY_IV=INTBODY_IV+1;  end;end;  %spocita pocet integracnich bodu v oblasti I - pocet cisel 1 v 7. sloupci

K_C1pp_cit=zeros(4,1);         %hodnota integralu na krivce C1 - integrovano po castech ("per partes") v oblsti I
K_C1pp_jme=zeros(4,1);

%integrace dolni celo az rozhrani (OBLAST I)
pruchodpp(1)=0;
%INT_POL1=X1(1,3);      %urci integracni polomer v dane oblasti
for i=1:2:INTBODY_I-2,   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1pp_cit(1) = K_C1pp_cit(1) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,6)  + 4*X1(i+1,6)  + X1(i+2,6));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1pp_jme(1) = K_C1pp_jme(1) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,11) + 4*X1(i+1,11) + X1(i+2,11));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(1)=pruchodpp(1)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%integrace  rozhrani az 90 stupnu (OBLAST II)
pruchodpp(2)=0 ;
%INT_POL2=X1(1,3);        %urci integracni polomer v dane oblasti
for i=INTBODY_I+1:2:(INTBODY_I+INTBODY_II-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1pp_cit(2) = K_C1pp_cit(2) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,6)  + 4*X1(i+1,6)  + X1(i+2,6));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1pp_jme(2) = K_C1pp_jme(2) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,11) + 4*X1(i+1,11) + X1(i+2,11));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(2)=pruchodpp(2)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%integrace   90 stupnu az rozhrani (OBLAST III)
pruchodpp(3)=0;
%INT_POL3=X1(k1,3);     %R1   %urci integracni polomer v dane oblasti
for i=(INTBODY_I+INTBODY_II+1):2:(INTBODY_I+INTBODY_II+INTBODY_III-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1pp_cit(3) = K_C1pp_cit(3) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,6)  + 4*X1(i+1,6)  + X1(i+2,6));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1pp_jme(3) = K_C1pp_jme(3) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,11) + 4*X1(i+1,11) + X1(i+2,11));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(3)=pruchodpp(3)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%integrace   rozhrani az horni celo (OBLAST IV)
pruchodpp(4)=0;
%INT_POL4=X1(k1,3);     %R1   %urci integracni polomer v dane oblasti
for i=(INTBODY_I+INTBODY_II+INTBODY_III+1):2:(length(X1)-2),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1pp_cit(4) = K_C1pp_cit(4) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,6)  + 4*X1(i+1,6)  + X1(i+2,6));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1pp_jme(4) = K_C1pp_jme(4) + X1(i+1,3) *((X1(i+2,2)-X1(i,2))/6) * (X1(i,11) + 4*X1(i+1,11) + X1(i+2,11));    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodpp(4)=pruchodpp(4)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;


pruchodpp1 = pruchodpp(1) + pruchodpp(2) + pruchodpp(3) + pruchodpp(4);  %kontrolni promenna

K_C1pp_citatel(krucek)    = K_C1pp_cit(1) + K_C1pp_cit(2) + K_C1pp_cit(3) + K_C1pp_cit(4);    %indexy v zavorkach znamenaji oblast ve ktere se integrovalo (vytvori se vlastne sloupcovy vektor, kde jednotlive radky jsou integrace pres jednotlive oblasti)
K_C1pp_jmenovatel(krucek) = K_C1pp_jme(1) + K_C1pp_jme(2) + K_C1pp_jme(3) + K_C1pp_jme(4);    %

K_C1_SimpsonPP(krucek) = K_C1pp_citatel(krucek) / K_C1pp_jmenovatel(krucek);

%*********************************************************************************************
%*************** I N T E G R A C E   P O   O B L A S T E C H  na C1 LICHOBEZNIK **************
%*********************************************************************************************
%Zde v nasledujicim  zkusime integraci po castech v kazdem materialu budeme integrovat zvlast- na rozhrani je totiz nespojitost - skokova zmena a ta
%muze pri numericke integraci zpusobovat chybu.
%Bude pouzita LICHOBEZNIKOVA  METODA

K_C1lichpp_cit=zeros(4,1);         %hodnota integralu na krivce C1 - integrovano po castech ("per partes") v oblsti I
K_C1lichpp_jme=zeros(4,1);

%integrace dolni celo az rozhrani (OBLAST I)
pruchodlichpp(1)=0;
for i=1:INTBODY_I-1,   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1lichpp_cit(1) = K_C1lichpp_cit(1) + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,6) +  X1(i+1,6))/2);    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1lichpp_jme(1) = K_C1lichpp_jme(1) + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,11) + X1(i+1,11))/2);    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodlichpp(1)=pruchodlichpp(1)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

%integrace  rozhrani az 90 stupnu (OBLAST II)
pruchodlichpp(2)=0 ;
for i=INTBODY_I+1:(INTBODY_I+INTBODY_II-1),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1lichpp_cit(2) = K_C1lichpp_cit(2) + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,6) +  X1(i+1,6))/2); %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1lichpp_jme(2) = K_C1lichpp_jme(2) + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,11) + X1(i+1,11))/2);   %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodlichpp(2)=pruchodlichpp(2)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%integrace   90 stupnu az rozhrani (OBLAST III)
pruchodlichpp(3)=0;
for i=(INTBODY_I+INTBODY_II+1):(INTBODY_I+INTBODY_II+INTBODY_III-1),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1lichpp_cit(3) = K_C1lichpp_cit(3)  + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,6) +  X1(i+1,6))/2);     %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1lichpp_jme(3) = K_C1lichpp_jme(3)  + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,11) + X1(i+1,11))/2);    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodlichpp(3)=pruchodlichpp(3)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;
%integrace   rozhrani az horni celo (OBLAST IV)
pruchodlichpp(4)=0;
for i=(INTBODY_I+INTBODY_II+INTBODY_III+1):(length(X1)-1),   %je zde -2 protoze potrebujeme aby pri i+2 dostali maximalne hodnotu INTBODY_I
     K_C1lichpp_cit(4) = K_C1lichpp_cit(4)  + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,6) +  X1(i+1,6))/2);    %Vypocet integralu na krivce C2 (vzdaleny od korene)     
     K_C1lichpp_jme(4) = K_C1lichpp_jme(4)  + ((X1(i+1,3)+X1(i,3))/2)*(X1(i+1,2)-X1(i,2)) * ((X1(i,11) + X1(i+1,11))/2);     %Vypocet integralu na krivce C2 (vzdaleny od korene)     
   pruchodlichpp(4)=pruchodlichpp(4)+1;   %kontrolni promenna (kolik mame "dvoj"intervalu na kterych integrujeme) - pruchody cyklem  
end;

pruchodlichpp1 = pruchodlichpp(1) + pruchodlichpp(2) + pruchodlichpp(3) + pruchodlichpp(4);  %kontrolni promenna

K_C1lichpp_citatel(krucek)    = K_C1lichpp_cit(1) + K_C1lichpp_cit(2) + K_C1lichpp_cit(3) + K_C1lichpp_cit(4);    %indexy v zavorkach znamenaji oblast ve ktere se integrovalo (vytvori se vlastne sloupcovy vektor, kde jednotlive radky jsou integrace pres jednotlive oblasti)
K_C1lichpp_jmenovatel(krucek) = K_C1lichpp_jme(1) + K_C1lichpp_jme(2) + K_C1lichpp_jme(3) + K_C1lichpp_jme(4);    %

K_C1_LichobPP(krucek) = K_C1lichpp_citatel(krucek) / K_C1lichpp_jmenovatel(krucek);



%**************************************************************************
%***** Nyni se vypot dodatkov energie uvolnn lomovm procesem *******
%**************************************************************************

GSIFappl=1

deltaW1(krucek) = K_C1_LichobPP(krucek)  * GSIFappl^2 * EPSI^(2*delta)   %vpoet zmny potenciln energie souvisejic s lomovm procesem - na ceste C1 
addW1(krucek) = deltaW1(krucek) - Gc * Delka_prirustku                  %pocitano z dat na integracni ceste C1

%*************************************************************************************************
%****** VYKRESLENI INTEGRACNICH CEST A NAZNACENI HLAVNI A PENETRUJICI TRHLINY
%*************************************************************************************************

figure(10);
subplot(2,2,krucek)
if iii==1, Nazev='Single deflection', end;
if iii==2, Nazev='Double deflection', end;
if iii==3, Nazev='Penetration', end;

 hor_celox(1)=0 ; hor_celox(2)=2*uzly_pathR1(1,3)*cosd(alfa-FI/2-90);   %dve x-ove souradnice definujici horni celo
 hor_celoy(1)=0 ; hor_celoy(2)=2*uzly_pathR1(1,3)*sind(alfa-FI/2-90);   %dve y-ove souradnice definujici horni celo
 dol_celox(1)=0 ; dol_celox(2)=2*uzly_pathR1(1,3)*cosd(alfa+FI/2-90);   %dve x-ove souradnice definujici dolni celo
 dol_celoy(1)=0 ; dol_celoy(2)=2*uzly_pathR1(1,3)*sind(alfa+FI/2-90);   %dve y-ove souradnice definujici dolni celo

 delam_x(1)=0 ; delam_x(2)= -EPSI*R4*sind(ALFAp);        %dve x-ove souradnice definujici delaminacni trhlinu - ad= 1.25*R1=1.25*EPSI*R4
 delam_y(1)=0 ; delam_y(2)= EPSI*R4*cosd(ALFAp);        %dve y-ove souradnice definujici delaminacni trhlinu

 if iii==2,              %tato podminka je pro pripad dvojnasobneho ohybu
   delam_x(1)=-EPSI*R4*sind(ALFAp)/2 ; delam_x(2)= EPSI*R4*sind(ALFAp)/2;        %dve x-ove souradnice definujici delaminacni trhlinu - ad= 1.25*R1=1.25*EPSI*R4
   delam_y(1)=0 ; delam_y(2)= EPSI*R4*cosd(ALFAp);                              %dve y-ove souradnice definujici delaminacni trhlinu
 end;

 polpopiskuy1=uzly_pathR1(1,3)/2;     
 polpopiskuy2=uzly_pathR1(1,3)/4;     
 
 plot(uzly_pathR1_sort(:,13).*cosd(uzly_pathR1_sort(:,12)-90+alfa)  ,  uzly_pathR1_sort(:,13).*sind(uzly_pathR1_sort(:,12)-90+alfa),'LineWidth',2,'Color','r') ; hold on; grid on;  
 plot(delam_x , delam_y,'LineWidth',3,'Color','g') ;  grid on; hold on;     %prikresli do grafu delaminacni trhlinu
 plot(hor_celox , hor_celoy,'LineWidth',3,'Color','k') ; hold on; grid on;   %prikresli do grafu horni celo trhliny
 plot(dol_celox , dol_celoy,'LineWidth',3,'Color','k') ; hold on; grid on;   %prikresli do grafu dolni celo trhliny
 xlim([-1.1*uzly_pathR1(1,3) 1.1*uzly_pathR1(1,3)]); 
 ylim([-1.1*uzly_pathR1(1,3) 1.1*uzly_pathR1(1,3)]);
 title(Nazev,'FontSize',12,'FontWeight','bold'), 
 xlabel('Osa x - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
 ylabel('Osa y - [mm]','FontName','times','FontSize',10,'FontWeight','bold'), 
  text(0,polpopiskuy1,['\delta W = ',num2str(deltaW1(krucek)),' MPa.m^2'],'FontSize',10,'FontWeight','bold');
  text(0,polpopiskuy2,['K_1 = ',num2str(K_C1_LichobPP(krucek)),' m^2^\delta/MPa'],'FontSize',10,'FontWeight','bold');

 axis equal;

 legend(['Integracni cesta R1= ' ,num2str(uzly_pathR1(1,3)),' mm'],['Delka prirustku= ',num2str(EPSI*R4),' mm'],2);



krucek=krucek+1;
XX1(:,:,krucek)=X1(:,:);  %vytvori se 3Dmatice, kde se budou ukladat hodnoty integracni matice X1 na ceste C1 v jednotlivych krocich



%clear A; clear uzly_pathR1; clear uzly_pathR1_sort;
%clear B; clear uzly_pathR2; clear uzly_pathR2_sort;

%[UXsin,UYsin,SXsin,SYsin,SXYsin,delta] = SingularSolution(180,Delka_prirustku,2,poradidelta);  %parametry teto funkce jsou UHELTHETA a vzdalenost od stredu RC1 (volime jednotkovou - aby se r vyrusilo; 3.parametr - 1 - pocita pomocne - dualni reseni , 2-pocita normalni singularni reseni
%tangfun= SXsin/Delka_prirustku^(delta-1) ;   

end;


%filename5=['MATLABUzly_na_outerdomain_proALFA=',num2str(alfa), '_FIopen=',num2str(FI),'.txt'];  %'_opacnematerialy',
%f5 = fullfile('D:', 'Ansys', 'Kriteria','Singleohyb','MATLABdata', filename5)  %prikaz ktery vytvori komplet cestu k danemu souboru
%fid=fopen(f5,'wt');  %otevre soubor s nazvem f5 a format souboru bude WRITE TEXT

